diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/power-rate-adaptation-test.cc ns-3.34/src/wifi/test/power-rate-adaptation-test.cc
--- ns-3.33/src/wifi/test/power-rate-adaptation-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/power-rate-adaptation-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,6 +26,9 @@
 #include "ns3/constant-position-mobility-model.h"
 #include "ns3/simulator.h"
 #include "ns3/test.h"
+#include "ns3/frame-exchange-manager.h"
+#include "ns3/wifi-default-protection-manager.h"
+#include "ns3/wifi-default-ack-manager.h"
 
 using namespace ns3;
 
@@ -40,7 +43,7 @@
 public:
   PowerRateAdaptationTest ();
 
-  virtual void DoRun (void);
+  void DoRun (void) override;
 private:
   /// Test parf function
   void TestParf ();
@@ -77,6 +80,15 @@
   Ptr<AdhocWifiMac> mac = CreateObject<AdhocWifiMac> ();
   mac->SetDevice (dev);
   mac->ConfigureStandard (WIFI_STANDARD_80211a);
+  Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager ();
+
+  Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
+  protectionManager->SetWifiMac (mac);
+  fem->SetProtectionManager (protectionManager);
+
+  Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager> ();
+  ackManager->SetWifiMac (mac);
+  fem->SetAckManager (ackManager);
 
   /*
    * Create mobility model. Is needed by the phy layer for transmission.
@@ -140,6 +152,7 @@
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
+  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (packet, packetHeader);
   WifiMode ackMode;
 
   /*
@@ -168,7 +181,7 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -184,7 +197,7 @@
    * As we are using recovery power, one failure make power increase.
    *
    */
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -201,10 +214,10 @@
    */
   for (int i = 0; i < 7; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
-      manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
+      manager->ReportDataFailed (mpdu);
     }
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+  manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -219,7 +232,7 @@
    * As we are using recovery power, one failure make power increase. recoveryPower=false.
    */
 
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -234,8 +247,8 @@
    * After two consecutive fails the rate is decreased or the power increased.
    * As we are at maximal power, the rate should be decreased.
    */
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -252,7 +265,7 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -268,7 +281,7 @@
    * As we are using recovery rate, one failure make rate decrease. recoveryRate=false.
    */
 
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -285,7 +298,7 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -303,7 +316,7 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -319,11 +332,11 @@
    * One successful transmissions after a power decrease make recoverPower=false.
    * So we need two consecutive failures to increase power again.
    */
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+  manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
 
   for (int i = 0; i < 2; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -361,6 +374,7 @@
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
+  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (packet, packetHeader);
   WifiMode ackMode;
 
   /*
@@ -390,7 +404,7 @@
    */
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -406,7 +420,7 @@
    * One failure make the power to be increased again.
    * Change to state Low.
    */
-  manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -424,7 +438,7 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -443,7 +457,7 @@
 
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -461,7 +475,7 @@
    */
   for (int i = 0; i < 16 * 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -477,7 +491,7 @@
    * After one fail the rate is decreased or the power increased.
    * As we are at minimal power, the power should be increased.
    */
-  manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -494,7 +508,7 @@
    */
   for (int i = 0; i < 16; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -511,7 +525,7 @@
    * As we are at maximal power, the rate should be decreased.
    * Set critical rate to 54 Mbps.
    */
-  manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -528,7 +542,7 @@
    */
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -548,7 +562,7 @@
    */
   for (int i = 0; i < 9 * 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -560,7 +574,7 @@
 
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -604,6 +618,7 @@
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
+  Ptr<WifiMacQueueItem> mpdu = Create<WifiMacQueueItem> (packet, packetHeader);
   WifiMode ackMode;
 
   /*
@@ -662,7 +677,7 @@
    */
   for (int i = 0; i < 6; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -675,7 +690,7 @@
   /**
    * Test that 7 is enough.
    */
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+  manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -692,7 +707,7 @@
    */
   for (int i = 0; i < 4; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -702,7 +717,7 @@
   NS_TEST_ASSERT_MSG_EQ (mode.GetDataRate (txVector.GetChannelWidth (), txVector.GetGuardInterval (), 1), 9000000, "RRPAA: Incorrect vale of data rate");
   NS_TEST_ASSERT_MSG_EQ (power, 17, "RRPAA: Incorrect value of power level");
 
-  manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+  manager->ReportDataFailed (mpdu);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -719,7 +734,7 @@
 
   for (int i = 0; i < 7; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -731,7 +746,7 @@
 
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -743,7 +758,7 @@
 
   for (int i = 0; i < 13; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -755,7 +770,7 @@
 
   for (int i = 0; i < 19; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -767,7 +782,7 @@
 
   for (int i = 0; i < 23; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -779,7 +794,7 @@
 
   for (int i = 0; i < 33; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -791,7 +806,7 @@
 
   for (int i = 0; i < 43; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -811,7 +826,7 @@
 
   for (int i = 0; i < 49; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -821,7 +836,7 @@
   NS_TEST_ASSERT_MSG_EQ (mode.GetDataRate (txVector.GetChannelWidth (), txVector.GetGuardInterval (), 1), 54000000, "RRPAA: Incorrect vale of data rate");
   NS_TEST_ASSERT_MSG_EQ (power, 17, "RRPAA: Incorrect value of power level");
 
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+  manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
 
   txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
@@ -839,7 +854,7 @@
 
   for (int i = 0; i < 16 * 50; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -857,7 +872,7 @@
 
   for (int i = 0; i < 6; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -875,7 +890,7 @@
 
   for (int i = 0; i < 16 * 6; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -893,7 +908,7 @@
 
   for (int i = 0; i < 6; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -909,7 +924,7 @@
 
   for (int i = 0; i < 11; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -929,7 +944,7 @@
 
   for (int i = 0; i < 25; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -941,7 +956,7 @@
 
   for (int i = 0; i < 5; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -953,7 +968,7 @@
 
   for (int i = 0; i < 5; i++)
     {
-      manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+      manager->ReportDataFailed (mpdu);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -965,7 +980,7 @@
 
   for (int i = 0; i < 25; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+      manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
     }
 
   txVector = manager->GetDataTxVector (packetHeader);
@@ -985,12 +1000,12 @@
     {
       for (int j = 0; j < 25; j++)
         {
-          manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
+          manager->ReportDataOk (mpdu, 0, ackMode, 0, txVector);
         }
 
       for (int j = 0; j < 5; j++)
         {
-          manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
+          manager->ReportDataFailed (mpdu);
         }
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.34/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.33/src/wifi/test/spectrum-wifi-phy-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/spectrum-wifi-phy-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -29,8 +29,9 @@
 #include "ns3/log.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/wifi-psdu.h"
-#include "ns3/wifi-ppdu.h"
+#include "ns3/ofdm-ppdu.h"
 #include "ns3/wifi-utils.h"
+#include "ns3/he-phy.h" //includes OFDM PHY
 
 using namespace ns3;
 
@@ -67,7 +68,8 @@
   virtual ~SpectrumWifiPhyBasicTest ();
 
 protected:
-  virtual void DoSetup (void);
+  void DoSetup (void) override;
+  void DoTeardown (void) override;
   Ptr<SpectrumWifiPhy> m_phy; ///< Phy
   /**
    * Make signal function
@@ -83,31 +85,34 @@
   /**
    * Spectrum wifi receive success function
    * \param psdu the PSDU
-   * \param snr the SNR
+   * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
    * \param txVector the transmit vector
    * \param statusPerMpdu reception status per MPDU
    */
-  void SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                                 WifiTxVector txVector, std::vector<bool> statusPerMpdu);
   /**
    * Spectrum wifi receive failure function
    * \param psdu the PSDU
--   */
+   */
   void SpectrumWifiPhyRxFailure (Ptr<WifiPsdu> psdu);
   uint32_t m_count; ///< count
 
 private:
-  virtual void DoRun (void);
+  void DoRun (void) override;
+
+  uint64_t m_uid; //!< the UID to use for the PPDU
 };
 
 SpectrumWifiPhyBasicTest::SpectrumWifiPhyBasicTest ()
-  : TestCase ("SpectrumWifiPhy test case receives one packet"),
-    m_count (0)
+  : SpectrumWifiPhyBasicTest ("SpectrumWifiPhy test case receives one packet")
 {
 }
 
 SpectrumWifiPhyBasicTest::SpectrumWifiPhyBasicTest (std::string name)
   : TestCase (name),
-    m_count (0)
+    m_count (0),
+    m_uid (0)
 {
 }
 
@@ -115,7 +120,7 @@
 Ptr<SpectrumSignalParameters>
 SpectrumWifiPhyBasicTest::MakeSignal (double txPowerWatts)
 {
-  WifiTxVector txVector = WifiTxVector (WifiPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false);
+  WifiTxVector txVector = WifiTxVector (OfdmPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false);
 
   Ptr<Packet> pkt = Create<Packet> (1000);
   WifiMacHeader hdr;
@@ -126,7 +131,7 @@
   Ptr<WifiPsdu> psdu = Create<WifiPsdu> (pkt, hdr);
   Time txDuration = m_phy->CalculateTxDuration (psdu->GetSize (), txVector, m_phy->GetPhyBand ());
 
-  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, WIFI_PHY_BAND_5GHZ);
+  Ptr<WifiPpdu> ppdu = Create<OfdmPpdu> (psdu, txVector, WIFI_PHY_BAND_5GHZ, m_uid++);
 
   Ptr<SpectrumValue> txPowerSpectrum = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity (FREQUENCY, CHANNEL_WIDTH, txPowerWatts, GUARD_WIDTH);
   Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters> ();
@@ -146,9 +151,10 @@
 }
 
 void
-SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
+SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, RxSignalInfo rxSignalInfo,
+                                                    WifiTxVector txVector, std::vector<bool> statusPerMpdu)
 {
-  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << rxSignalInfo << txVector);
   m_count++;
 }
 
@@ -178,6 +184,13 @@
   m_phy->SetReceiveErrorCallback (MakeCallback (&SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxFailure, this));
 }
 
+void
+SpectrumWifiPhyBasicTest::DoTeardown (void)
+{
+  m_phy->Dispose ();
+  m_phy = 0;
+}
+
 // Test that the expected number of packet receptions occur.
 void
 SpectrumWifiPhyBasicTest::DoRun (void)
@@ -219,50 +232,49 @@
   virtual ~TestPhyListener ()
   {
   }
-  virtual void NotifyRxStart (Time duration)
+  void NotifyRxStart (Time duration) override
   {
     NS_LOG_FUNCTION (this << duration);
     ++m_notifyRxStart;
   }
-  virtual void NotifyRxEndOk (void)
+  void NotifyRxEndOk (void) override
   {
     NS_LOG_FUNCTION (this);
     ++m_notifyRxEndOk;
   }
-  virtual void NotifyRxEndError (void)
+  void NotifyRxEndError (void) override
   {
     NS_LOG_FUNCTION (this);
     ++m_notifyRxEndError;
   }
-  virtual void NotifyTxStart (Time duration, double txPowerDbm)
+  void NotifyTxStart (Time duration, double txPowerDbm) override
   {
     NS_LOG_FUNCTION (this << duration << txPowerDbm);
   }
-  virtual void NotifyMaybeCcaBusyStart (Time duration)
+  void NotifyMaybeCcaBusyStart (Time duration) override
   {
     NS_LOG_FUNCTION (this);
     ++m_notifyMaybeCcaBusyStart;
   }
-  virtual void NotifySwitchingStart (Time duration)
+  void NotifySwitchingStart (Time duration) override
   {
   }
-  virtual void NotifySleep (void)
+  void NotifySleep (void) override
   {
   }
-  virtual void NotifyOff (void)
+  void NotifyOff (void) override
   {
   }
-  virtual void NotifyWakeup (void)
+  void NotifyWakeup (void) override
   {
   }
-  virtual void NotifyOn (void)
+  void NotifyOn (void) override
   {
   }
   uint32_t m_notifyRxStart; ///< notify receive start
   uint32_t m_notifyRxEndOk; ///< notify receive end OK
   uint32_t m_notifyRxEndError; ///< notify receive end error
   uint32_t m_notifyMaybeCcaBusyStart; ///< notify maybe CCA busy start
-private:
 };
 
 /**
@@ -277,8 +289,8 @@
   SpectrumWifiPhyListenerTest ();
   virtual ~SpectrumWifiPhyListenerTest ();
 private:
-  virtual void DoSetup (void);
-  virtual void DoRun (void);
+  void DoSetup (void) override;
+  void DoRun (void) override;
   TestPhyListener* m_listener; ///< listener
 };
 
@@ -307,7 +319,7 @@
   Simulator::Run ();
 
   NS_TEST_ASSERT_MSG_EQ (m_count, 1, "Didn't receive right number of packets");
-  NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyMaybeCcaBusyStart, 2, "Didn't receive NotifyMaybeCcaBusyStart (preamble deteted + L-SIG received)");
+  NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyMaybeCcaBusyStart, 2, "Didn't receive NotifyMaybeCcaBusyStart (once preamble is detected + prolonged by L-SIG reception, then switched to Rx by at the beginning of data)");
   NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyRxStart, 1, "Didn't receive NotifyRxStart");
   NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyRxEndOk, 1, "Didn't receive NotifyRxEnd");
 
@@ -334,8 +346,9 @@
   virtual ~SpectrumWifiPhyFilterTest ();
 
 private:
-  virtual void DoSetup (void);
-  virtual void DoRun (void);
+  void DoSetup (void) override;
+  void DoTeardown (void) override;
+  void DoRun (void) override;
 
   /**
    * Run one function
@@ -349,7 +362,6 @@
 
   /**
    * Callback triggered when a packet is received by the PHYs
-   * \param context the context
    * \param p the received packet
    * \param rxPowersW the received power per channel band in watts
    */
@@ -360,6 +372,8 @@
 
   uint16_t m_txChannelWidth; ///< TX channel width (MHz)
   uint16_t m_rxChannelWidth; ///< RX channel width (MHz)
+
+  std::set<WifiSpectrumBand> m_ruBands; ///< spectrum bands associated to all the RUs
 };
 
 SpectrumWifiPhyFilterTest::SpectrumWifiPhyFilterTest ()
@@ -377,7 +391,7 @@
 void
 SpectrumWifiPhyFilterTest::SendPpdu (void)
 {
-  WifiTxVector txVector = WifiTxVector (WifiPhy::GetHeMcs0 (), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, m_txChannelWidth, false, false);
+  WifiTxVector txVector = WifiTxVector (HePhy::GetHeMcs0 (), 0, WIFI_PREAMBLE_HE_SU, 800, 1, 1, 0, m_txChannelWidth, false, false);
   Ptr<Packet> pkt = Create<Packet> (1000);
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_QOSDATA);
@@ -407,34 +421,8 @@
   expectedNumBands += (m_rxChannelWidth / 40);
   expectedNumBands += (m_rxChannelWidth / 80);
   expectedNumBands += (m_rxChannelWidth / 160);
-  if (m_rxChannelWidth == 20)
-    {
-      expectedNumBands += 9; /* RU_26_TONE */
-      expectedNumBands += 4; /* RU_52_TONE */
-      expectedNumBands += 2; /* RU_106_TONE */
-      expectedNumBands += 1; /* RU_242_TONE */
-    }
-  else if (m_rxChannelWidth == 40)
-    {
-      expectedNumBands += 18; /* RU_26_TONE */
-      expectedNumBands += 8; /* RU_52_TONE */
-      expectedNumBands += 4; /* RU_106_TONE */
-      expectedNumBands += 2; /* RU_242_TONE */
-      expectedNumBands += 1; /* RU_484_TONE */
-    }
-  else if (m_rxChannelWidth >= 80)
-    {
-      expectedNumBands += 37 * (m_rxChannelWidth / 80); /* RU_26_TONE */
-      expectedNumBands += 16 * (m_rxChannelWidth / 80); /* RU_52_TONE */
-      expectedNumBands += 8 * (m_rxChannelWidth / 80); /* RU_106_TONE */
-      expectedNumBands += 4 * (m_rxChannelWidth / 80); /* RU_242_TONE */
-      expectedNumBands += 2 * (m_rxChannelWidth / 80); /* RU_484_TONE */
-      expectedNumBands += 1 * (m_rxChannelWidth / 80); /* RU_996_TONE */
-      if (m_rxChannelWidth == 160)
-        {
-          ++expectedNumBands; /* RU_2x996_TONE */
-        }
-    }
+  expectedNumBands += m_ruBands.size ();
+
   NS_TEST_ASSERT_MSG_EQ (numBands, expectedNumBands, "Total number of bands handled by the receiver is incorrect");
 
   uint16_t channelWidth = std::min (m_txChannelWidth, m_rxChannelWidth);
@@ -510,9 +498,17 @@
 }
 
 void
+SpectrumWifiPhyFilterTest::DoTeardown (void)
+{
+  m_txPhy->Dispose ();
+  m_txPhy = 0;
+  m_rxPhy->Dispose ();
+  m_rxPhy = 0;
+}
+
+void
 SpectrumWifiPhyFilterTest::RunOne (void)
 {
-  m_txPhy->SetChannelWidth (m_txChannelWidth);
   uint16_t txFrequency;
   switch (m_txChannelWidth)
     {
@@ -532,7 +528,6 @@
     }
   m_txPhy->SetFrequency (txFrequency);
 
-  m_rxPhy->SetChannelWidth (m_rxChannelWidth);
   uint16_t rxFrequency;
   switch (m_rxChannelWidth)
     {
@@ -552,6 +547,26 @@
     }
   m_rxPhy->SetFrequency (rxFrequency);
 
+  m_ruBands.clear ();
+  for (uint16_t bw = 160; bw >= 20; bw = bw / 2)
+    {
+      for (uint8_t i = 0; i < (m_rxChannelWidth / bw); ++i)
+        {
+          for (unsigned int type = 0; type < 7; type++)
+            {
+              HeRu::RuType ruType = static_cast <HeRu::RuType> (type);
+              for (std::size_t index = 1; index <= HeRu::GetNRus (bw, ruType); index++)
+                {
+                  HeRu::SubcarrierGroup group = HeRu::GetSubcarrierGroup (bw, ruType, index);
+                  HeRu::SubcarrierRange range = std::make_pair (group.front ().first, group.back ().second);
+                  WifiSpectrumBand band = m_rxPhy->ConvertHeRuSubcarriers (bw, m_rxPhy->GetGuardBandwidth (m_rxChannelWidth),
+                                                                           range, i);
+                  m_ruBands.insert (band);
+                }
+            }
+        }
+    }
+
   Simulator::Schedule (Seconds (1), &SpectrumWifiPhyFilterTest::SendPpdu, this);
   
   Simulator::Run ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/tx-duration-test.cc ns-3.34/src/wifi/test/tx-duration-test.cc
--- ns-3.33/src/wifi/test/tx-duration-test.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/tx-duration-test.cc	2021-07-14 10:31:07.000000000 -0700
@@ -26,6 +26,9 @@
 #include "ns3/he-ru.h"
 #include "ns3/wifi-psdu.h"
 #include "ns3/packet.h"
+#include "ns3/dsss-phy.h"
+#include "ns3/erp-ofdm-phy.h"
+#include "ns3/he-phy.h" //includes OFDM, HT, and VHT
 #include <numeric>
 
 using namespace ns3;
@@ -43,13 +46,13 @@
 public:
   TxDurationTest ();
   virtual ~TxDurationTest ();
-  virtual void DoRun (void);
+  void DoRun (void) override;
 
 
 private:
   /**
    * Check if the payload tx duration returned by InterferenceHelper
-   * corresponds to a known value of the pay
+   * corresponds to a known value
    *
    * @param size size of payload in octets (includes everything after the PHY header)
    * @param payloadMode the WifiMode used for the transmission
@@ -64,7 +67,7 @@
 
   /**
    * Check if the overall tx duration returned by InterferenceHelper
-   * corresponds to a known value of the pay
+   * corresponds to a known value
    *
    * @param size size of payload in octets (includes everything after the PHY header)
    * @param payloadMode the WifiMode used for the transmission
@@ -246,7 +249,7 @@
   NS_ASSERT (sizes.size () == userInfos.size () && sizes.size () > 1);
   NS_ABORT_MSG_IF (channelWidth < std::accumulate (std::begin (userInfos), std::end (userInfos), 0,
                                                    [](const uint16_t prevBw, const HeMuUserInfo &info)
-                                                   { return prevBw + HeRu::GetBandwidth (info.ru.ruType); }),
+                                                   { return prevBw + HeRu::GetBandwidth (info.ru.GetRuType ()); }),
                    "Cannot accommodate all the RUs in the provided band"); //MU-MIMO (for which allocations use the same RU) is not supported
   WifiTxVector txVector;
   txVector.SetPreambleType (WIFI_PREAMBLE_HE_MU);
@@ -328,10 +331,10 @@
 
   //IEEE Std 802.11-2007 Table 18-2 "Example of LENGTH calculations for CCK"
   retval = retval
-    && CheckPayloadDuration (1023, WifiPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (744))
-    && CheckPayloadDuration (1024, WifiPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (745))
-    && CheckPayloadDuration (1025, WifiPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (746))
-    && CheckPayloadDuration (1026, WifiPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (747));
+    && CheckPayloadDuration (1023, DsssPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (744))
+    && CheckPayloadDuration (1024, DsssPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (745))
+    && CheckPayloadDuration (1025, DsssPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (746))
+    && CheckPayloadDuration (1026, DsssPhy::GetDsssRate11Mbps (), 22, 800, WIFI_PREAMBLE_LONG, MicroSeconds (747));
 
   NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11b CCK duration failed");
 
